<?php

namespace App|C\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Segment StructType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:Segment
 * @subpackage Structs
 */
class Segment extends CityPair
{
    /**
     * The AirlineDesignator
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AirlineDesignator;
    /**
     * The FlightInfo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \App|C\StructType\FlightInfo
     */
    public $FlightInfo;
    /**
     * Constructor method for Segment
     * @uses Segment::setAirlineDesignator()
     * @uses Segment::setFlightInfo()
     * @param string $airlineDesignator
     * @param \App|C\StructType\FlightInfo $flightInfo
     */
    public function __construct($airlineDesignator = null, \App|C\StructType\FlightInfo $flightInfo = null)
    {
        $this
            ->setAirlineDesignator($airlineDesignator)
            ->setFlightInfo($flightInfo);
    }
    /**
     * Get AirlineDesignator value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAirlineDesignator()
    {
        return isset($this->AirlineDesignator) ? $this->AirlineDesignator : null;
    }
    /**
     * Set AirlineDesignator value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $airlineDesignator
     * @return \App|C\StructType\Segment
     */
    public function setAirlineDesignator($airlineDesignator = null)
    {
        // validation for constraint: string
        if (!is_null($airlineDesignator) && !is_string($airlineDesignator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($airlineDesignator, true), gettype($airlineDesignator)), __LINE__);
        }
        if (is_null($airlineDesignator) || (is_array($airlineDesignator) && empty($airlineDesignator))) {
            unset($this->AirlineDesignator);
        } else {
            $this->AirlineDesignator = $airlineDesignator;
        }
        return $this;
    }
    /**
     * Get FlightInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \App|C\StructType\FlightInfo|null
     */
    public function getFlightInfo()
    {
        return isset($this->FlightInfo) ? $this->FlightInfo : null;
    }
    /**
     * Set FlightInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \App|C\StructType\FlightInfo $flightInfo
     * @return \App|C\StructType\Segment
     */
    public function setFlightInfo(\App|C\StructType\FlightInfo $flightInfo = null)
    {
        if (is_null($flightInfo) || (is_array($flightInfo) && empty($flightInfo))) {
            unset($this->FlightInfo);
        } else {
            $this->FlightInfo = $flightInfo;
        }
        return $this;
    }
}
